# jirify
[![Gem Version](https://badge.fury.io/rb/jirify.svg)](https://badge.fury.io/rb/jirify)
[![Build Status](https://travis-ci.org/GeorgeSG/jirify.svg?branch=master)](https://travis-ci.org/GeorgeSG/jirify)
[![Coverage Status](https://coveralls.io/repos/github/GeorgeSG/jirify/badge.svg?branch=master)](https://coveralls.io/github/GeorgeSG/jirify?branch=master)

A simple ruby gem that helps me work with jira

## Installation
1. Run `gem install jirify`.
1. Execute `jira setup` and go through the setup process.
1. Optionally source `$HOME/.jirify/jirify.bash_completion.sh` to have
autocomplete in bash.
1. Execute `jira` and `jira <command> help` to learn about available commands.

## Config Explained
Currently, the config structure of `jirify` is:
- `$HOME/.jirify` folder that contains:
  - `.jirify` - yaml file generated by `jira setup`
  - `jirify.bash_completion.sh` - bash completion script you can source.
  This is placed here by `jira setup`, so if you don't see it or you want to
  refresh it, run `jira setup` again.
  - `.cache` - cache for completion script

### Config file: `$HOME/.jirify/.jirify`
```yaml
options:
  username: <atlassian username (email)>
  token: <token generated from https://id.atlassian.com>
  site: <JIRA url>
  projects:
    - <JIRA project key>
  filter_by_labels:
    - <label to filter by when displaying sprint>
  verbose: <force jirify to always be verbose>
```

## To Do
- Tests:
  - [ ] Test CLI classes.
  - [ ] Test UI classes.
  - [ ] Test `Models::Issue`.
  - [ ] Test `Models::Transition`, `Models::BaseList` (?).
  - [ ] Test `Config::copy_bash_completion!`.
- [ ] Refactor Models - `BaseList` doesn't make much sense.
- [x] ~~Refactor `SprintCell`:~~
  - [x] ~~It should be a more general `IssueRenderer`.~~
  - [x] ~~Use it for `jira issues describe` with additional option to draw border.~~
- [ ] Adjust `jira issues mine` to terminal width.
- [ ] Add ability to define mapping between custom statuses and custom
transitions in config.
- [ ] Add ability to specify custom filters when listing issues (both
`jira sprint` and `jira issues`)
